
ChiliProject - Bug # 474: Changesets are displaying the wrong user and commit date in the Activity

Status: Closed Priority: Normal
Author: Dennis Karmelk Category: Journals / History
Created: 2011-06-14 Assignee: Eric Davis
Updated: 2011-06-17 Due date:
Remote issue URL:
Affected version: unstable
Description: When we add an existing SVN repository to a project, the updates are correctly linked to the chili users under 

repository author column. But when looking at the activities, they are hooked to the wrong user. Under 
activity, all revisions are linked to one user. The list looks like this:
<Date>
Revision XX: <text>
<Wrong user>

When you click on a activity you get:
Revision XX
Added by <correct user> about <time> ago
<text>

Associated revisions
2011-06-17 09:29 pm - Eric Davis
[#474] Changesets should use the author method for events

This will let them pick up the committer string if user is nil

2011-06-17 09:39 pm - Eric Davis
[#474] aaj should use the Model's activity options for timestamp and author_key

Some models (Changeset) require custom options passed to
acts_as_activity_provider but acts_as_journalized wasn't accepting these
for :timestamp or :author_key

History
2011-06-16 07:50 pm - Felix Schäfer
- Assignee set to Dennis Karmelk

- Status changed from Open to Needs more information

Is this for data that has been migrated (i.e. existed before) or data that's being added to ChiliProject 2.0? If migrated: From Redmine or ChiliProject, and 
from what version? If newly imported, through what means (cron, autoupdate, â€¦)?

2011-06-16 09:59 pm - Felix Schäfer
OK, I think I've found the problem: @ChangesetJournals@ get created with the default user for journals, which is @User.current@, which is wrong in 
most cases.

2011-06-17 07:23 am - Dennis Karmelk
- File chili2.jpg added

- File chili1.jpg added
No, it's no migration, but a new setup. I've attached some pictures to clarify what goes wrong. To reproduce:
Create a SVN repo or use an existing one.
Make sure there are some commits with two or more users.
Add the svn repo to a new project.
Activities are generated from SVN, all with the user who added the SVN repo.

I have no idea what you say in the last comment, but it sounds like that may be the problem :-)

2011-06-17 08:38 am - Felix Schäfer
Dennis Karmelk wrote:
> I have no idea what you say in the last comment, but it sounds like that may be the problem :-)

It probably is, I'm trying to think of a good way to correct the wrong data you currently have in your DB thoughâ€¦

2011-06-17 04:44 pm - Felix Schäfer
So the problem is "in @Changeset.rb@":/projects/chiliproject/repository/revisions/release-v2.0.0/entry/app/models/changeset.rb#L22, journals get 
created with @User.current@ because the @Changeset@ journals aren't initialized with the @user@ of the @Changeset@, and the @created_at@ 
date of the journal is wrong too, as it defaults to "now" but should be the @committed_on@ of the journal.

I'm not sure having a journal for the @Changeset@ s is a good fit though, as they (currently) don't change anyway, or they should be converted to 
@Journal@ s altogether, a little like the wiki pages are, though I'm not sure how doable that would be because @Changeset has_many :changes@ (if 
those changes are not queried against, then by all means let's get rid of them and dump them into the changes of a journal-based @Changeset@).

2011-06-17 05:08 pm - Eric Davis
- Assignee changed from Dennis Karmelk to Eric Davis

- Status changed from Needs more information to Open

Thanks Felix, I'll try to take a look at this.

2011-06-17 08:12 pm - Eric Davis
- Subject changed from SVN and activities link broken to Changesets are displaying the wrong user and commit date in the Activity

- Category changed from User accounts to Journals / History

- (deleted custom field) set to unstable

- Status changed from Open to Closed

I've fixed the activity module for Changesets. What was happening was acts_as_journalized wasn't letting the Changeset model override some options 
for acts_as_event and acts_as_activity.  So it was showing the ChangesetJournal#author instead of the committer and the 
ChangesetJournal#created_at time instead of the committed_on date.

One thing to watch for: this page is cached using an etag so if the results still don't look correct after upgrading, try to restart your web server (or 
otherwise clear the etag).

commit:7c751b350

Files
chili1.jpg 26.4 kB 2011-06-17 Dennis Karmelk
chili2.jpg 11.9 kB 2011-06-17 Dennis Karmelk
